; example2.nsi
;
; This script is based on example1.nsi, but it remember the directory, 
; has uninstall support and (optionally) installs start menu shortcuts.
;
; It will install Subdownloader.nsi into a directory that the user selects,

;--------------------------------

; The name of the installer
Name "Subdownloader"

; The file to write
OutFile "subdownloader_inst.exe"

; The default installation directory
InstallDir $PROGRAMFILES\Subdownloader

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\Subdownloader" "Install_Dir"

;--------------------------------

; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

; The stuff to install
Section "Subdownloader (required)"

  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there
  File /r *.*
  
  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\Subdownloader "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Subdownloader" "DisplayName" "Babiloo"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Subdownloader" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Subdownloader" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Subdownloader" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\Subdownloader"
  CreateShortCut "$SMPROGRAMS\Subdownloader\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\Subdownloader\Subdownloader.lnk" "$INSTDIR\Subdownloader.exe" "" "$INSTDIR\Subdownloader.exe" 0
  
SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Subdownloader"
  DeleteRegKey HKLM SOFTWARE\Subdownloader

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\Subdownloader\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\Subdownloader"
  RMDir /r "$INSTDIR"

SectionEnd
